#!/usr/bin/perl
#
# paico-gui.pl - graphical interface to paico
#	21.10.99 - (C) Benjamin Fuhrmannek <fuhrmannek@web.de>
#

use Tk;

sub cntl {
  my $i;
  print CNTL "$_[0]";
  if ($_[0] >= 1 && $_[0] <= 8) {
    if ($button[$_[0]]->cget(-relief) eq "raised") { $button[$_[0]]->configure(-relief => "sunken"); }
	else { $button[$_[0]]->configure(-relief => "raised"); }
  } elsif ($_[0] == 0) {
    for ($i = 1; $i <= 8; $i++) { $button[$i]->configure(-relief => "raised"); }
  } elsif ($_[0] == 9) {
    for ($i = 1; $i <= 8; $i++) { $button[$i]->configure(-relief => "sunken"); }
  }
}

sub info {
  $infobutton->configure(-relief => "sunken");
  while (!$info->Show eq "OK") {}
  $infobutton->configure(-relief => "raised");
}

open(CNTL,"|./paico >/dev/null") || die $!;
select((select(CNTL), $| = 1)[0]);

$main = MainWindow->new(-title => "Parallel Interface Control");
$buttons = $main->Frame()->pack(-side => "top");
%buttonpack = (-side => "left");

$button[0] = $buttons->Button(-text => "off", -command => sub { cntl(0); })->pack(%buttonpack);
$button[1] = $buttons->Button(-text => "1", -command => sub { cntl(1); })->pack(%buttonpack);
$button[2] = $buttons->Button(-text => "2", -command => sub { cntl(2); })->pack(%buttonpack);
$button[3] = $buttons->Button(-text => "3", -command => sub { cntl(3); })->pack(%buttonpack);
$button[4] = $buttons->Button(-text => "4", -command => sub { cntl(4); })->pack(%buttonpack);
$button[5] = $buttons->Button(-text => "5", -command => sub { cntl(5); })->pack(%buttonpack);
$button[6] = $buttons->Button(-text => "6", -command => sub { cntl(6); })->pack(%buttonpack);
$button[7] = $buttons->Button(-text => "7", -command => sub { cntl(7); })->pack(%buttonpack);
$button[8] = $buttons->Button(-text => "8", -command => sub { cntl(8); })->pack(%buttonpack);
$button[9] = $buttons->Button(-text => "on", -command => sub { cntl(9); })->pack(%buttonpack);

$infobutton = $buttons->Button(-text => "Info", -command => \&info)->pack(%buttonpack);
$buttons->Button(-text => "Quit", -command => sub { $main->destroy; })->pack(%buttonpack);


$main->bind('<KeyPress-0>' => sub { cntl(0); });
$main->bind('<KeyPress-1>' => sub { cntl(1); });
$main->bind('<KeyPress-2>' => sub { cntl(2); });
$main->bind('<KeyPress-3>' => sub { cntl(3); });
$main->bind('<KeyPress-4>' => sub { cntl(4); });
$main->bind('<KeyPress-5>' => sub { cntl(5); });
$main->bind('<KeyPress-6>' => sub { cntl(6); });
$main->bind('<KeyPress-7>' => sub { cntl(7); });
$main->bind('<KeyPress-8>' => sub { cntl(8); });
$main->bind('<KeyPress-9>' => sub { cntl(9); });
$main->bind('<q>' => sub { $main->destroy; });


$info = $main->DialogBox(-title => "Info", -buttons => ["OK"]);
$info->Label(-text => "Author: Benjamin Fuhrmannek <fuhrmannek\@web.de>")->pack;

MainLoop;

close(CNTL);

