/*
 * Compile with `gcc -O2 [...]'.
 * paico - parallel interface control program
 *	21.10.99 - (C) Ben Fuhrmannek <ben@fuhrmannek.de>
 */

#include <stdio.h>
#include <unistd.h>
#include <asm/io.h>

#define BASEPORT 0x278 /* lp2 */
/*#define BASEPORT 0x378 /* lp1 */

int li[7];

int calc_val() {
  int val;
  val = (1*li[0])+(2*li[1])+(4*li[2])+(8*li[3])+(16*li[4])+(32*li[5])+(64*li[6])+(128*li[7]);
  return val;
}

toggle(int l_num) {
  if (li[l_num - 1] == 0) li[l_num - 1] = 1;
	else li[l_num - 1] = 0;
  l_set(calc_val());
}

l_set(int l_val) {
  outb(l_val,BASEPORT);
}

int l_get() {
  int get_val;
  get_val = inb(BASEPORT+1);
  return get_val;
}

main() {
  int i, ex = 0;
  char c;

  for (i = 0; i <= 7; i++) li[i] = 0;
  if (ioperm(BASEPORT,3,1)) {perror("ioperm");exit(1);}
  outb(0,BASEPORT);

  while (ex == 0) {
    c = getchar();
    switch(c) {
    case '0': for (i = 0; i <= 7; i++) li[i] = 0; l_set(0); break;
    case '1': toggle(1); break;
    case '2': toggle(2); break;
    case '3': toggle(3); break;
    case '4': toggle(4); break;
    case '5': toggle(5); break;
    case '6': toggle(6); break;
    case '7': toggle(7); break;
    case '8': toggle(8); break;
    case '9': for (i = 0; i <= 7; i++) li[i] = 1; l_set(255); break;
    case 'i': printf("%d",l_get());
    case EOF: ex = 1; break; /* EOF = Quit */
    default: break; /* unknown input */
    }
  }

  l_set(0);
  if (ioperm(BASEPORT,3,0)) {perror("ioperm");exit(1);}
}
